#include <iostream>
#include <map>
#include <vector>
#define int long long
using namespace std;

int32_t main()
{
    string s;
    cin>>s;
    int n=s.size(),as=0,as1=0;
    vector<int>v;
    for(int i=0;i<n-1;i++)
    {
        if(s[i]>s[i+1]){v.push_back(i+1);as++;}
    }
    for(int i=0;i<v.size();i++)
        cout<<v[i]<<' ';
    int q;
    cin>>q;
    while(q--)
    {
        as1=0;
        int l,r;
        cin>>l>>r;
        for(int i=0;i<v.size();i++)
        {
            if(v[i]<l)as1++;
            else break;
        }
        for(int i=v.size()-1;i>=0;i--)
        {
            if(v[i]>=r)as1++;
            else break;
        }
        cout<<as+1-as1<<endl;
    }
    return 0;
}
